﻿package com.ludoko.pit
{
	import com.adamatomic.flixel.FlxBlock;
	import com.adamatomic.flixel.FlxButton;
	import com.adamatomic.flixel.FlxG;
	import com.adamatomic.flixel.FlxSprite;
	import com.adamatomic.flixel.FlxState;
	import com.adamatomic.flixel.FlxText;
	
	public class GameOverState extends FlxState
	{
		[Embed(source="../../../data/imgs/cursor.png")] private var ImgCursor:Class;
		[Embed(source="../../../data/imgs/bg.png")] private var ImgBG:Class;
		[Embed(source="../../../data/imgs/wall.png")] private var ImgWall:Class;
		[Embed(source="../../../data/imgs/gameover.png")] private var ImgGameOver:Class;
		
		private var _timer:Number;
		private var _fading:Boolean;
		
		private var _gameOver:FlxSprite;
		
		private var _score:FlxText;
		private var _distance:FlxText;
		
		private var _replay:FlxButton;
		private var _menu:FlxButton;
		
		public function GameOverState() 
		{
			super();
			
			_timer = 0;
			_fading = false;
			
			this.add(new FlxBlock(0, 0, FlxG.width, FlxG.height, ImgBG, int(Math.random() * 40)));
			
			//this.add(new FlxBlock(0, 0, 16, FlxG.height, ImgWall));
			//this.add(new FlxBlock(FlxG.width - 16, 0, 16, FlxG.height, ImgWall));
			
			_gameOver = this.add(new FlxSprite(ImgGameOver, 65, 70, false, false, 115, 66)) as FlxSprite;
			_gameOver.alpha = 0;
			
			_score = this.add(new FlxText(3, FlxG.height / 2 + 10, FlxG.width, 80, "FINAL SCORE: " + FlxG.scores[0], 0xa29e8e, null, 8, "center")) as FlxText;
			_score.alpha = 0;
			_distance = this.add(new FlxText(3, FlxG.height / 2 + 34, FlxG.width, 80, "FINAL DEPTH: " + FlxG.scores[1].toFixed(0) + " M", 0xa29e8e, null, 8, "center")) as FlxText;
			_distance.alpha = 0;
			
			var back:FlxSprite = new FlxSprite(null, 0, 0, false, false, 80, 15, 0xff656256);
			var highlightedBack:FlxSprite = new FlxSprite(null, 0, 0, false, false, 80, 15, 0xffa29e8e);
			var text:FlxText = new FlxText(24, 1, 100, 10, "Replay", 0xa29e8e);
			var highlightedText:FlxText = new FlxText(24, 1, 100, 10, "Replay", 0xffffff);
			_replay = this.add(new FlxButton(FlxG.width / 2 - 37, 240, back, replay, highlightedBack, text, highlightedText)) as FlxButton;
			_replay.ignoreMouse = true;
			_replay.alpha = 0;
			
			back = new FlxSprite(null, 0, 0, false, false, 80, 15, 0xff656256);
			highlightedBack = new FlxSprite(null, 0, 0, false, false, 80, 15, 0xffa29e8e);
			text = new FlxText(14, 1, 100, 10, "Main Menu", 0xa29e8e);
			highlightedText = new FlxText(14, 1, 100, 10, "Main Menu", 0xffffff);
			_menu = this.add(new FlxButton(FlxG.width / 2 - 37, 264, back, gotoMenu, highlightedBack, text, highlightedText)) as FlxButton;
			_menu.ignoreMouse = true;
			_menu.alpha = 0;
			
			FlxG.setCursor(ImgCursor);
		}
		
		override public function update():void
		{
			super.update();
			
			_timer += FlxG.elapsed;
			
			if (_gameOver.alpha < 1)
				_gameOver.alpha += 0.25 * FlxG.elapsed;
			
			if (_score.alpha < 1)
				_score.alpha += 0.25 * FlxG.elapsed;
			if (_distance.alpha < 1)
				_distance.alpha += 0.25 * FlxG.elapsed;
			
			if (_timer > 3 && _replay.alpha < 1)
				_replay.alpha += 0.25 * FlxG.elapsed;
			if (_replay.alpha >= 1)
				_replay.ignoreMouse = false;
			
			if (_timer > 3 && _menu.alpha < 1)
				_menu.alpha += 0.25 * FlxG.elapsed;
			if (_menu.alpha >= 1)
				_menu.ignoreMouse = false;
		}
		
		private function replay():void
		{
			FlxG.switchState(PlayState);
		}
		
		private function gotoMenu():void
		{
			FlxG.switchState(MenuState);
		}
	}
	
}