﻿package com.ludoko.pit
{
	import com.adamatomic.flixel.FlxArray;
	import com.adamatomic.flixel.FlxButton;
	import com.adamatomic.flixel.FlxBlock;
	import com.adamatomic.flixel.FlxG;
	import com.adamatomic.flixel.FlxLayer;
	import com.adamatomic.flixel.FlxState;
	import com.adamatomic.flixel.FlxSprite;
	import com.adamatomic.flixel.FlxText;
	
	public class MenuState extends FlxState
	{
		[Embed(source="../../../data/imgs/cursor.png")] private var ImgCursor:Class;
		[Embed(source="../../../data/imgs/bg.png")] private var ImgBG:Class;
		[Embed(source="../../../data/imgs/wall.png")] private var ImgWall:Class;
		[Embed(source="../../../data/imgs/title.png")] private var ImgTitle:Class;
		[Embed(source="../../../data/imgs/subtitle.png")] private var ImgSubtitle:Class;
		
		[Embed(source="../../../data/audio/rumble.mp3")] private var SndRumble:Class;
		
		
		private var _timer:Number;
		
		private var _diveSpeed:Number;
		
		private var _bgs:FlxArray;
		private var _bgLayer:FlxLayer;
		
		private var _walls:FlxArray;
		private var _wallLayer:FlxLayer;
		
		private var _title:FlxSprite;
		private var _subtitle:FlxSprite;
		
		private var _startGame:FlxButton;
		private var _credits:FlxButton;
		
		public function MenuState() 
		{
			super();
			
			_timer = 0;
			
			_diveSpeed = 35;
			
			_bgs = new FlxArray();
			_bgLayer = this.add(new FlxLayer) as FlxLayer;
			_bgs.add(_bgLayer.add(new FlxBlock(0, 0, FlxG.width, FlxG.height, ImgBG, int(Math.random() * 40))));
			_bgs.add(_bgLayer.add(new FlxBlock(0, FlxG.height, FlxG.width, FlxG.height, ImgBG, int(Math.random() * 40))));
			
			_walls = new FlxArray();
			_wallLayer = this.add(new FlxLayer) as FlxLayer;
			_walls.add(_wallLayer.add(new FlxBlock(0, 0, 16, FlxG.height, ImgWall)));
			_walls.add(_wallLayer.add(new FlxBlock(FlxG.width - 16, 0, 16, FlxG.height, ImgWall)));
			_walls.add(_wallLayer.add(new FlxBlock(0, FlxG.height, 16, FlxG.height, ImgWall)));
			_walls.add(_wallLayer.add(new FlxBlock(FlxG.width - 16, FlxG.height, 16, FlxG.height, ImgWall)));
			
			_title = this.add(new FlxSprite(ImgTitle, 65, 70, false, false, 115, 83)) as FlxSprite;
			_title.alpha = 0;
			
			_subtitle = this.add(new FlxSprite(ImgSubtitle, 67, 180, false, false, 110, 10)) as FlxSprite;
			_subtitle.alpha = 0;
			
			var back:FlxSprite = new FlxSprite(null, 0, 0, false, false, 80, 15, 0xff656256);
			var highlightedBack:FlxSprite = new FlxSprite(null, 0, 0, false, false, 80, 15, 0xffa29e8e);
			var text:FlxText = new FlxText(27, 1, 100, 10, "Start", 0xa29e8e);
			var highlightedText:FlxText = new FlxText(27, 1, 100, 10, "Start", 0xffffff);
			_startGame = this.add(new FlxButton(FlxG.width / 2 - 37, 240, back, startGame, highlightedBack, text, highlightedText)) as FlxButton;
			_startGame.ignoreMouse = true;
			_startGame.alpha = 0;
			
			back = new FlxSprite(null, 0, 0, false, false, 80, 15, 0xff656256);
			highlightedBack = new FlxSprite(null, 0, 0, false, false, 80, 15, 0xffa29e8e);
			text = new FlxText(16, 1, 100, 10, "More Info", 0xa29e8e);
			highlightedText = new FlxText(16, 1, 100, 10, "More Info", 0xffffff);
			_credits = this.add(new FlxButton(FlxG.width / 2 - 37, 264, back, gotoSite, highlightedBack, text, highlightedText)) as FlxButton;
			_credits.ignoreMouse = true;
			_credits.alpha = 0;
			
			FlxG.setMusic(SndRumble, 0.7, true);
			
			FlxG.setCursor(ImgCursor);
		}
		
		override public function update():void
		{
			var i:int;
			
			super.update();
			
			var block:FlxBlock;
			for (i = 0; i < _bgs.length; i++)
			{
				block = _bgs[i];
				block.y -= _diveSpeed * FlxG.elapsed / 10;
				if (block.y <= -FlxG.height)
				{
					_bgs[i] = _bgLayer.add(new FlxBlock(0, block.y + FlxG.height * 2 - 1, FlxG.width, FlxG.height, ImgBG, int(Math.random() * 40)));
					_bgLayer.remove(block);
				}
			}
			
			for (i = 0; i < _walls.length; i++)
			{
				block = _walls[i];
				block.y -= _diveSpeed * FlxG.elapsed;
				if (block.y <= -FlxG.height)
				{
					_walls[i] = _wallLayer.add(new FlxBlock(block.x, block.y + FlxG.height * 2 - 1, 16, FlxG.height, ImgWall));
					_wallLayer.remove(block);
				}
			}
			
			_timer += FlxG.elapsed;
			
			if (_timer > 3 && _title.alpha < 1)
				_title.alpha += 0.25 * FlxG.elapsed;
			
			if (_timer > 5 && _subtitle.alpha < 1)
				_subtitle.alpha += 0.25 * FlxG.elapsed;
			
			if (_timer > 5 && _startGame.alpha < 1)
				_startGame.alpha += 0.25 * FlxG.elapsed;
			if (_startGame.alpha >= 1)
				_startGame.ignoreMouse = false;
			
			if (_timer > 5 && _credits.alpha < 1)
				_credits.alpha += 0.25 * FlxG.elapsed;
			if (_credits.alpha >= 1)
				_credits.ignoreMouse = false;
			
			if (Math.random() < 0.03)
				FlxG.quake(0.001, 0.2);
		}
		
		private function startGame():void
		{
			FlxG.switchState(PlayState);
		}
		
		private function gotoSite():void
		{
			FlxG.openURL("http://gamedrinkcode.com");
		}
	}
	
}