﻿package com.ludoko.pit
{
	import com.adamatomic.flixel.FlxG;
	import com.adamatomic.flixel.FlxSprite;
	
	public class ScoreCombos extends FlxSprite
	{
		[Embed(source="../../../data/imgs/combos.png")] private var ImgCombos:Class;
		
		private var _timer:Number;
		
		public function ScoreCombos(X:int, Y:int, Combo:int)
		{
			super(ImgCombos, X - 4, Y + 4, true, false);
			
			_timer = 0;
			
			addAnimation("2x", [0]);
			addAnimation("3x", [1]);
			addAnimation("4x", [2]);
			addAnimation("5x", [3]);
			addAnimation("6x", [4]);
			addAnimation("7x", [5]);
			addAnimation("8x", [6]);
			addAnimation("9x", [7]);
			addAnimation("?x", [8]);
			
			showCombo(Combo);
		}
		
		override public function update():void 
		{
			super.update();
			
			if (dead)
				return;
			
			_timer += FlxG.elapsed;
			y -= 20 * FlxG.elapsed;
			alpha = (1 - _timer) / 1;
			if (_timer > 1)
				kill();
		}
		
		public function reset(X:int, Y:int, Combo:int):void
		{
			exists = true;
			dead = false;
			
			_timer = 0;
			alpha = 1;
			
			x = X - 4;
			y = Y + 4;
			
			showCombo(Combo);
		}
		
		public function showCombo(Combo:int):void
		{
			switch (Combo) 
			{
				case 2:
					play("2x");
					break;
				case 3:
					play("3x");
					break;
				case 4:
					play("4x");
					break;
				case 5:
					play("5x");
					break;
				case 6:
					play("6x");
					break;
				case 7:
					play("7x");
					break;
				case 8:
					play("8x");
					break;
				case 9:
					play("9x");
					break;
				default:
					play("?x");
					break;
			}
		}
	}
}