﻿package com.ludoko.pit
{
	import com.adamatomic.flixel.FlxG;
	import com.adamatomic.flixel.FlxSprite;
	
	public class ScorePoints extends FlxSprite
	{
		[Embed(source="../../../data/imgs/points.png")] private var ImgPoints:Class;
		
		private var _timer:Number;
		
		public function ScorePoints(X:int, Y:int, Points:int)
		{
			super(ImgPoints, X - 9, Y - 9, true, false);
			
			_timer = 0;
			
			addAnimation("100", [0]);
			addAnimation("200", [1]);
			addAnimation("400", [2]);
			addAnimation("800", [4]);
			addAnimation("1600", [5]);
			addAnimation("3200", [6]);
			
			showPoints(Points);
		}
		
		override public function update():void 
		{
			super.update();
			
			if (dead)
				return;
			
			_timer += FlxG.elapsed;
			y -= 20 * FlxG.elapsed;
			alpha = (1 - _timer) / 1;
			if (_timer > 1)
				kill();
		}
		
		public function reset(X:int, Y:int, Points:int):void
		{
			exists = true;
			dead = false;
			
			_timer = 0;
			alpha = 1;
			
			x = X - 9;
			y = Y - 9;
			
			showPoints(Points);
		}
		
		public function showPoints(Points:int):void
		{
			switch (Points) 
			{
				case 100:
					play("100");
					break;
				case 200:
					play("200");
					break;
				case 400:
					play("400");
					break;
				case 800:
					play("800");
					break;
				case 1600:
					play("1600");
					break;
				case 3200:
					play("3200");
					break;
			}
		}
	}
}